import javax.microedition.lcdui.*;
import java.util.*;

public class ElementList extends List implements CommandListener { 
 midlet midlet;
 Displayable parent;
 Vector items;
 Image green,red;

 ElementList (String title, Vector items, midlet midlet, Displayable parent) { 
  super (title + ":"+items.size(), IMPLICIT);
  this.items = items;
  this.midlet = midlet;
  this.parent = parent;
  String s,add;
  int k;
  try {
   green = Image.createImage("/green.png");
   red = Image.createImage("/red.png");
  }
  catch (java.io.IOException e) {}
  
  for (int i=0; i<items.size(); i++) {
   s=items.elementAt(i).toString();
   if (s.length()<32) { k=s.length(); add=""; }
   else { k=32; add="..."; }
   append (s.substring(1,k)+add,(s.substring(0,1).indexOf((int)'#')>-1?green:red));
  }
  setCommandListener (this);
  if (items.size()>1) addCommand(midlet.SEARCH_CMD);
  addCommand(midlet.BACK_CMD); 
  Display.getDisplay(midlet).setCurrent(this);
 }

 public void commandAction(Command c, Displayable d) {
  if (c == midlet.SEARCH_CMD) { 
   new SearchBox (items, midlet, this);
  } 
  else if (c == midlet.BACK_CMD) { 
   Display.getDisplay(midlet).setCurrent(parent);
  } 
  else { 
   String mark=items.elementAt(getSelectedIndex()).toString().substring(0,1),
    msg=items.elementAt(getSelectedIndex()).toString().substring(1);
   if (mark.indexOf((int)'#')>-1) 
    new Message (midlet, this, Settings.EventHdr).show (msg);
   else
    new Message (midlet, this, Settings.MyEventHdr).show (msg);
  }
 }

}