import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import java.util.*;
import java.io.*;

public class midlet extends MIDlet implements CommandListener { 
 List main;
 Command BACK_CMD, SEARCH_CMD, QUIT_CMD, OK_CMD, DELETE_CMD;
 CyrillicWinReader reader;
 public Vector items,labels,date1,date2;
 gaugeForm gauge;
 public String item;
 public int k,All;
 int i;
 public recordStores rs=null;

 public final int[] monthDays = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
 public final String [] monthStr = { "", "", "", "", "", "", "", "", "", "", "", "" };
 private String [] pics = { "search", "search", "add", "help", "help", "exit" };
 private Image [] icons = { null,null,null,null,null,null };

 public midlet() { 
  BACK_CMD = new Command(Settings.BackCommand, Command.BACK, 0);
  SEARCH_CMD = new Command(Settings.SearchCommand, Command.OK, 0);
  QUIT_CMD = new Command(Settings.ExitCommand, Command.EXIT, 0);
  OK_CMD = new Command(Settings.OkCommand, Command.OK, 0);
  DELETE_CMD = new Command(Settings.DeleteCommand, Command.ITEM, 1);

  reader=new CyrillicWinReader(getClass().getResourceAsStream(Settings.DataBase));
  items = new Vector ();
  labels = new Vector ();
  date1 = new Vector ();
  date2 = new Vector ();
  rs = new recordStores ();
  All=rs.getNumRecords();
  for (int l=0; l<6; l++) {
   try { icons[l] = Image.createImage("/"+pics[l]+".png"); }
   catch (java.io.IOException e) {}
  }
  main = new List (getMainTitle(), List.IMPLICIT, Settings.menu, icons);
  main.setCommandListener(this);
  gauge = new gaugeForm (this,main,Settings.LoadStr,10,Settings.All+All);
  Display.getDisplay(this).setCurrent(gauge);
 }

 public String getMainTitle () {
  return Settings.ApplicationHdr+" ("+(Settings.All+All)+")";
 }

 public void setMainTitle () {
  main.setTitle (getMainTitle());
 }

 protected void destroyApp (boolean unconditional) {
  String item,newitem; 
  int p,k=1;
  if (Settings.pack==1) {
   main.setTitle (Settings.PackStr);
   for (int l=Settings.All; l<Settings.All+All; l++) {
    item=items.elementAt(l).toString();
    //System.out.println (item);
    if (item.startsWith (""+Settings.DeletedMark)==true) {
     newitem=""+Settings.DeletedMark;
    }
    else {
     p=item.indexOf(Settings.DateFieldSeparator);
     newitem=labels.elementAt(l-Settings.All).toString()+Settings.Dividor+item.substring(p+Settings.DateFieldSeparator.length());
    }
    //System.out.println (newitem+" "+k);
    rs.setRecord (k,newitem);
    k++;
   }
   if (k<rs.getNumRecords()) {
    for (int l=k; l<=rs.getNumRecords(); l++)
     rs.setRecord (l,""+Settings.DeletedMark);
   }
  }
  rs.closeRecords ();
 }

 protected void pauseApp() {}

 public boolean leapYear (int year) {
  if ( (year%4==0) && (year%100!=0) || (year%400==0) ) {
   monthDays[1]= 29; return true;
  } 
  else { monthDays[1]=28; return false; }
 }

 public String getMaxDay (int m,int y) {
  leapYear (y);
  return ""+monthDays[m-1];
 }

 public String getMonthStr (int m) { return monthStr[m]; }

 private int getNumber (String s) {
  int v;
  try { v=Integer.parseInt (s); }
  catch (NumberFormatException e) { v=0; }
  return v;
 }

 public String Nulls2 (String s) {
  return (s.length()==1 ? "0"+s : s);
 }

 public int putDate (String d, int mode) {
  int p1=d.indexOf((int)Settings.dateSeparator),p2;
  String day,m,y;
  try {
   if (p1<0) {// 
    d=d.trim();
    if (getNumber(d)<1) return 0;
    if (mode==1) {
     item = d;
     return getNumber (d+"0101") ;
    }
    else {
     if (item.indexOf(d)==-1) item += Settings.period + d + Settings.Years;
     else item = d + Settings.Year;
     return getNumber (d+"1231") ;
    }
   }
   else {
    p2=d.indexOf((int)Settings.dateSeparator,p1+1);
    if (p2==-1) { //  
     m=d.substring(0,p1).trim();
     y=d.substring(p1+1).trim();
     if ( (getNumber(y)!=0) && (getNumber(m)!=0) ) {
      if (getNumber(y)<1 || getNumber(m)<1 || getNumber(m)>12) return 0;
      if (mode==1) {
       item = getMonthStr(getNumber(m)-1)+" "+y;
       return getNumber(y+Nulls2(m)+"01");
      }
      else {
       if (item.indexOf(y)==-1) item += "-";
       else {
        if (item.indexOf(getMonthStr(getNumber(m)-1))>-1) item=""; //   - 2006
        else item = item.substring(0,item.indexOf(" ")) + "-";
       }
       item += getMonthStr(getNumber(m)-1)+" "+y+Settings.Year;
       return getNumber(y+Nulls2(m)+getMaxDay(getNumber(m),getNumber(y)));
      }
     }
     else return 0;
    }
    else {//..
     day=d.substring(0,p1).trim();
     m=d.substring(p1+1,p2).trim();
     y=d.substring(p2+1).trim();
     if ( (getNumber(y)!=0) && (getNumber(m)!=0) && (getNumber(day)!=0) ) {
      if (getNumber(y)<1 || getNumber(m)<1 || getNumber(m)>12 || getNumber(day)<1 || getNumber(day)>getNumber(getMaxDay(getNumber(m),getNumber(y))) ) return 0;
      if (mode==1) item = day + " " + getMonthStr(getNumber(m)-1) + " " + y+"-";
      else {
       if (item.indexOf(y)>-1) { //  
        if (item.indexOf(getMonthStr(getNumber(m)-1))==-1) { // 
         item = item.substring(0,item.lastIndexOf((int)(' ')))+"-";
        }
        else { //  
         item = item.substring(0,item.indexOf(" "));
         if (item.indexOf(day)>-1) item=""; //  
         else item += "-";
        }
       }
       item += day + " " + getMonthStr(getNumber(m)-1) + " " + y;
      }
      return getNumber(y+Nulls2(m)+Nulls2(day));
     }
     else return 0;
    }
   }
  }
  catch (StringIndexOutOfBoundsException x) { return 0; }
 }

 public int putRecord (String s) {
  String d,d1,d2;
  int r,p1,p2,c,j,k1,k2;
  if (s.length()<1) return 0;
  i=s.indexOf(Settings.Dividor);
  if (i==-1) return 0;
  d=s.substring(0,i);
  r=d.indexOf((int)Settings.period);
  if (r>0) { //
   d1=d.substring(0,r).trim();
   d2=d.substring(r+1).trim();
   for (j=0,k1=0; j<d1.length(); j++) 
    if (d1.charAt (j)==Settings.dateSeparator) k1++;
   for (j=0,k2=0; j<d2.length(); j++) 
    if (d2.charAt (j)==Settings.dateSeparator) k2++;
   if (k1>2 || k2>2 || k1>k2) return 0;
   if (k1+1==k2) 
    d1 += d2.substring(d2.lastIndexOf((int)Settings.dateSeparator));
   else if (k1+2==k2)
    d1 += d2.substring(d2.indexOf(Settings.dateSeparator));
   c=d.indexOf(Settings.Century);
   if (c>-1) { // 
    d2=d2.substring(0,d2.indexOf(Settings.Century)).trim();
    if ( (getNumber(d1)!=0) && (getNumber(d2)!=0) ) {
     p1=putDate(""+((getNumber(d1)-1)*100+1),1);
     p2=putDate(""+((getNumber(d2)-1)*100+100),2);
     if (p1==0 || p2==0 || p1>=p2) return 0;
     else { 
      date1.addElement(Integer.toString(p1)); 
      date2.addElement(Integer.toString(p2));
     }
     item = d.trim();
    }
    else return 0;
   }
   else { // 
    p1=putDate(d1,1);
    p2=putDate(d2,2);
    if (p1==0 || p2==0 || p1>=p2) return 0;
    else {
     date1.addElement(Integer.toString(p1));
     date2.addElement(Integer.toString(p2));
    }
   }
  }
  else { // 
   c=d.indexOf(Settings.Century);
   if (c>-1) { //
    d=d.substring(0,c).trim();
    if (getNumber(d)!=0) {
     p1=putDate(""+((getNumber(d)-1)*100+1),1);
     p2=putDate(""+((getNumber(d)-1)*100+100),2);
     if (p1==0 || p2==0) return 0;
     else { 
      date1.addElement(Integer.toString(p1));
      date2.addElement(Integer.toString(p2));
     }
    }
    else return 0;
    item=d+" "+Settings.Century;
   }
   else { //
    p1=putDate(d,1);
    p2=putDate(d,2);
    if (p1==0 || p2==0) return 0;
    else {
     date1.addElement(Integer.toString(p1));
     date2.addElement(Integer.toString(p2));
    }
   }
  }
  return 1;
 }
  
 protected void startApp() {
  String s;
  k=1;
  try {
   for (int l=0; l<Settings.All; l++) {
    s=reader.readUTF ();
    item = "";
    if (s!=null) {
     if (putRecord (s)>0) items.addElement ("#"+item+Settings.DateFieldSeparator+s.substring(i+Settings.Dividor.length()));
     else { error (k); return; }
    }
    gauge.draw (k);
    k++;
   }
   reader.close();
  }
  catch (IOException x) { error (k); return; }
  catch (StringIndexOutOfBoundsException x) { error (k); return; }

  int bad=0;
  //System.out.println ("in base:"+All);
  if (All>0) for (int n=0; n<All; n++) {
   s=rs.getRecord (n+1);
   //System.out.println ("get:"+s);
   if (s!=null) {
    if (putRecord (s)>0 && s.startsWith(""+Settings.DeletedMark)==false) {
     items.addElement ("@"+item+Settings.DateFieldSeparator+s.substring(i+Settings.Dividor.length()));
     labels.addElement (s.substring(0,i));
    }
    else {
     bad++;
     //System.out.println ("bad:"+s);
    }
   }
   else bad++;
   //System.out.println (date1.size()+" "+date2.size()+" "+items.size());
   gauge.draw (k);
   k++;
  }
  All-=bad;
  setMainTitle ();
  Display.getDisplay(this).setCurrent(main);
 }

 public void error (int k) {
  new Message (this, main, Settings.ErrorHdr).show (Settings.ErrorString+k);
 }

 public void quit() { 
  destroyApp(true);
  notifyDestroyed();
 }

 public void commandAction(Command c, Displayable d)  {
  if (c==List.SELECT_COMMAND) {
   int selector = main.getSelectedIndex();
   switch (selector) {
    case 0: 
     new SearchBox (items, date1, date2, this, main);
    break;
    case 1: 
     new SearchBox (items, this, main);
    break;
    case 2:
     new addForm (this,main);
    break;
    case 3:
     new Message (this, main, Settings.menu[3]).show (Settings.HelpTxt);
    break;
    case 4:
     new Message (this, main, Settings.menu[4]).show (Settings.AboutTxt);
    break;
    case 5:
     quit();
    break;
   }
  }
 }

}    
           	